diff -ur nagios-cvs/base/commands.c nagios-threadsafe/base/commands.c
--- nagios-cvs/base/commands.c	2006-12-22 01:43:17.000000000 +0000
+++ nagios-threadsafe/base/commands.c	2006-12-22 11:07:19.000000000 +0000
@@ -85,7 +85,7 @@
 
 extern pthread_t       worker_threads[TOTAL_WORKER_THREADS];
 extern circular_buffer external_command_buffer;
-extern unsigned long   external_command_buffer_slots;
+extern int             external_command_buffer_slots;
 
 
 
diff -ur nagios-cvs/base/config.c nagios-threadsafe/base/config.c
--- nagios-cvs/base/config.c	2006-12-22 01:43:17.000000000 +0000
+++ nagios-threadsafe/base/config.c	2006-12-22 11:24:38.000000000 +0000
@@ -166,8 +166,8 @@
 extern host		**host_hashlist;
 extern service		**service_hashlist;
 
-extern unsigned long   external_command_buffer_slots;
-extern unsigned long   check_result_buffer_slots;
+extern int             external_command_buffer_slots;
+extern int             check_result_buffer_slots;
 
 
 
@@ -1404,10 +1404,10 @@
 			}
 
 		else if(!strcmp(variable,"external_command_buffer_slots"))
-			external_command_buffer_slots=strtoul(value,NULL,0);
+			external_command_buffer_slots=strtod(value,NULL);
 
 		else if(!strcmp(variable,"check_result_buffer_slots"))
-			check_result_buffer_slots=strtoul(value,NULL,0);
+			check_result_buffer_slots=strtod(value,NULL);
 
 		/*** AUTH_FILE VARIABLE USED BY EMBEDDED PERL INTERPRETER ***/
 		else if(!strcmp(variable,"auth_file")){
diff -ur nagios-cvs/base/events.c nagios-threadsafe/base/events.c
--- nagios-cvs/base/events.c	2006-12-22 01:43:18.000000000 +0000
+++ nagios-threadsafe/base/events.c	2006-12-22 11:06:58.000000000 +0000
@@ -89,7 +89,7 @@
 
 sched_info scheduling_info;
 
-extern unsigned long   check_result_buffer_slots;
+extern int             check_result_buffer_slots;
 
 
 /******************************************************************/
diff -ur nagios-cvs/base/nagios.c nagios-threadsafe/base/nagios.c
--- nagios-cvs/base/nagios.c	2006-12-22 10:11:32.000000000 +0000
+++ nagios-threadsafe/base/nagios.c	2006-12-22 11:06:29.000000000 +0000
@@ -207,8 +207,8 @@
 circular_buffer  external_command_buffer;
 circular_buffer  service_result_buffer;
 pthread_t worker_threads[TOTAL_WORKER_THREADS];
-unsigned long   external_command_buffer_slots=DEFAULT_EXTERNAL_COMMAND_BUFFER_SLOTS;
-unsigned long   check_result_buffer_slots=DEFAULT_CHECK_RESULT_BUFFER_SLOTS;
+int             external_command_buffer_slots=DEFAULT_EXTERNAL_COMMAND_BUFFER_SLOTS;
+int             check_result_buffer_slots=DEFAULT_CHECK_RESULT_BUFFER_SLOTS;
 
 
 
diff -ur nagios-cvs/base/nagiostats.c nagios-threadsafe/base/nagiostats.c
--- nagios-cvs/base/nagiostats.c	2006-12-22 10:11:32.000000000 +0000
+++ nagios-threadsafe/base/nagiostats.c	2006-12-22 11:50:25.879792500 +0000
@@ -140,10 +140,12 @@
 int active_hosts_checked_last_15min=0;
 int active_hosts_checked_last_1hour=0;
 
-unsigned long max_external_command_buffer_slots=0L;
-unsigned long used_external_command_buffer_slots=0L;
-unsigned long max_check_result_buffer_slots=0L;
-unsigned long used_check_result_buffer_slots=0L;
+int max_external_command_buffer_slots=0;
+int high_external_command_buffer_slots=0;
+int used_external_command_buffer_slots=0;
+int max_check_result_buffer_slots=0;
+int high_check_result_buffer_slots=0;
+int used_check_result_buffer_slots=0;
 
 
 
@@ -269,8 +271,10 @@
 		printf(" NAGIOSPID          pid number of Nagios deamon.\n");
 		printf(" NAGIOSVERPID       string with Nagios version and PID.\n");
 		printf(" MAXCMDBUF          number of external command buffer slots available.\n");
+		printf(" HIGHCMDBUF         high water mark of number of external command buffer slots used.\n");
 		printf(" USEDCMDBUF         number of external command buffer slots currently in use.\n");
 		printf(" MAXCHKBUF          number of check result buffer slots available.\n");
+		printf(" HIGHCHKBUF         high water mark of number of check result buffer slots used.\n");
 		printf(" USEDCHKBUF         number of check result buffer slots currently in use.\n");
 		printf(" NUMSERVICES        total number of services.\n");
 		printf(" NUMHOSTS           total number of hosts.\n");
@@ -380,13 +384,17 @@
 
 
 		else if(!strcmp(temp_ptr,"MAXCMDBUF"))
-			printf("%lu\n",max_external_command_buffer_slots);
+			printf("%d\n",max_external_command_buffer_slots);
+		else if(!strcmp(temp_ptr,"HIGHCMDBUF"))
+			printf("%d\n",high_external_command_buffer_slots);
 		else if(!strcmp(temp_ptr,"USEDCMDBUF"))
-			printf("%lu\n",used_external_command_buffer_slots);
+			printf("%d\n",used_external_command_buffer_slots);
 		else if(!strcmp(temp_ptr,"MAXCHKBUF"))
-			printf("%lu\n",max_check_result_buffer_slots);
+			printf("%d\n",max_check_result_buffer_slots);
+		else if(!strcmp(temp_ptr,"HIGHCHKBUF"))
+			printf("%d\n",high_check_result_buffer_slots);
 		else if(!strcmp(temp_ptr,"USEDCHKBUF"))
-			printf("%lu\n",used_check_result_buffer_slots);
+			printf("%d\n",used_check_result_buffer_slots);
 
 		else if(!strcmp(temp_ptr,"NUMSERVICES"))
 			printf("%d\n",status_service_entries);
@@ -585,8 +593,8 @@
 	get_time_breakdown(time_difference,&days,&hours,&minutes,&seconds);
 	printf("Program Running Time:                 %dd %dh %dm %ds\n",days,hours,minutes,seconds);
 	printf("Nagios PID:                           %lu\n",nagios_pid);
-	printf("Used/Max External Command Buffers:    %lu / %lu\n",used_external_command_buffer_slots,max_external_command_buffer_slots);
-	printf("Used/Max Check Result Buffers:        %lu / %lu\n",used_check_result_buffer_slots,max_check_result_buffer_slots);
+	printf("Used/High/Max External Cmd Buffers:   %d / %d / %d\n",used_external_command_buffer_slots,high_external_command_buffer_slots,max_external_command_buffer_slots);
+	printf("Used/High/Max Check Result Buffers:   %d / %d / %d\n",used_check_result_buffer_slots,high_check_result_buffer_slots,max_check_result_buffer_slots);
 	printf("\n");
 	printf("Total Services:                       %d\n",status_service_entries);
 	printf("Services Checked:                     %d\n",services_checked);
@@ -961,13 +969,17 @@
 				if(!strcmp(var,"program_start"))
 					program_start=strtoul(val,NULL,10);
 				else if(!strcmp(var,"max_external_command_buffer_slots"))
-					max_external_command_buffer_slots=strtoul(val,NULL,10);
+					max_external_command_buffer_slots=strtod(val,NULL);
+				else if(!strcmp(var,"high_external_command_buffer_slots"))
+					high_external_command_buffer_slots=strtod(val,NULL);
 				else if(!strcmp(var,"used_external_command_buffer_slots"))
-					used_external_command_buffer_slots=strtoul(val,NULL,10);
+					used_external_command_buffer_slots=strtod(val,NULL);
 				else if(!strcmp(var,"max_check_result_buffer_slots"))
-					max_check_result_buffer_slots=strtoul(val,NULL,10);
+					max_check_result_buffer_slots=strtod(val,NULL);
+				else if(!strcmp(var,"high_check_result_buffer_slots"))
+					high_check_result_buffer_slots=strtod(val,NULL);
 				else if(!strcmp(var,"used_check_result_buffer_slots"))
-					used_check_result_buffer_slots=strtoul(val,NULL,10);
+					used_check_result_buffer_slots=strtod(val,NULL);
 				else if(!strcmp(var,"nagios_pid"))
 					nagios_pid=strtoul(val,NULL,10);
 				break;
diff -ur nagios-cvs/base/utils.c nagios-threadsafe/base/utils.c
--- nagios-cvs/base/utils.c	2006-12-22 01:43:19.000000000 +0000
+++ nagios-threadsafe/base/utils.c	2006-12-22 11:25:34.000000000 +0000
@@ -209,8 +209,8 @@
 extern circular_buffer external_command_buffer;
 extern circular_buffer service_result_buffer;
 extern circular_buffer event_broker_buffer;
-extern unsigned long   external_command_buffer_slots;
-extern unsigned long   check_result_buffer_slots;
+extern int             external_command_buffer_slots;
+extern int             check_result_buffer_slots;
 
 /* from GNU defines errno as a macro, since it's a per-thread variable */
 #ifndef errno
@@ -4689,6 +4689,7 @@
 	external_command_buffer.head=0;
 	external_command_buffer.tail=0;
 	external_command_buffer.items=0;
+	external_command_buffer.high=0;
 	external_command_buffer.overflow=0L;
 	external_command_buffer.buffer=(void **)malloc(external_command_buffer_slots*sizeof(char **));
 	if(external_command_buffer.buffer==NULL)
@@ -4898,6 +4899,9 @@
 				if(service_result_buffer.items<check_result_buffer_slots)
 					service_result_buffer.items++;
 
+				if (service_result_buffer.items > service_result_buffer.high)
+					service_result_buffer.high = service_result_buffer.items;
+
 				/* release lock on buffer */
 				pthread_mutex_unlock(&service_result_buffer.buffer_lock);
 			        }
@@ -5029,6 +5033,10 @@
 		/* increment the head counter and items */
 		external_command_buffer.head=(external_command_buffer.head + 1) % external_command_buffer_slots;
 		external_command_buffer.items++;
+
+		if (external_command_buffer.items > external_command_buffer.high)
+			external_command_buffer.high = external_command_buffer.items;
+
 	        }
 
 	/* buffer was full */
diff -ur nagios-cvs/include/nagios.h.in nagios-threadsafe/include/nagios.h.in
--- nagios-cvs/include/nagios.h.in	2006-12-22 01:43:19.000000000 +0000
+++ nagios-threadsafe/include/nagios.h.in	2006-12-22 10:55:19.000000000 +0000
@@ -460,6 +460,7 @@
 	int             tail;
 	int             head;
 	int             items;
+	int             high;
 	unsigned long   overflow;
 	pthread_mutex_t buffer_lock;
         }circular_buffer;
diff -ur nagios-cvs/xdata/xsddefault.c nagios-threadsafe/xdata/xsddefault.c
--- nagios-cvs/xdata/xsddefault.c	2006-12-22 01:43:20.000000000 +0000
+++ nagios-threadsafe/xdata/xsddefault.c	2006-12-22 11:28:47.000000000 +0000
@@ -86,8 +86,8 @@
 extern int process_performance_data;
 extern int aggregate_status_updates;
 
-extern unsigned long external_command_buffer_slots;
-extern unsigned long check_result_buffer_slots;
+extern int external_command_buffer_slots;
+extern int check_result_buffer_slots;
 extern circular_buffer external_command_buffer;
 extern circular_buffer service_result_buffer;
 
@@ -367,10 +367,20 @@
 	fprintf(fp,"\tprocess_performance_data=%d\n",process_performance_data);
 	fprintf(fp,"\tglobal_host_event_handler=%s\n",(global_host_event_handler==NULL)?"":global_host_event_handler);
 	fprintf(fp,"\tglobal_service_event_handler=%s\n",(global_service_event_handler==NULL)?"":global_service_event_handler);
-	fprintf(fp,"\tmax_external_command_buffer_slots=%lu\n",external_command_buffer_slots);
-	fprintf(fp,"\tused_external_command_buffer_slots=%lu\n",external_command_buffer.items);
-	fprintf(fp,"\tmax_check_result_buffer_slots=%lu\n",check_result_buffer_slots);
-	fprintf(fp,"\tused_check_result_buffer_slots=%lu\n",service_result_buffer.items);
+	fprintf(fp,"\tmax_external_command_buffer_slots=%d\n",external_command_buffer_slots);
+
+	pthread_mutex_lock(&external_command_buffer.buffer_lock);
+	fprintf(fp,"\thigh_external_command_buffer_slots=%d\n",external_command_buffer.high);
+	fprintf(fp,"\tused_external_command_buffer_slots=%d\n",external_command_buffer.items);
+	pthread_mutex_unlock(&external_command_buffer.buffer_lock);
+
+	fprintf(fp,"\tmax_check_result_buffer_slots=%d\n",check_result_buffer_slots);
+
+	pthread_mutex_lock(&service_result_buffer.buffer_lock);
+	fprintf(fp,"\thigh_check_result_buffer_slots=%d\n",service_result_buffer.high);
+	fprintf(fp,"\tused_check_result_buffer_slots=%d\n",service_result_buffer.items);
+	pthread_mutex_unlock(&service_result_buffer.buffer_lock);
+
 	fprintf(fp,"\t}\n\n");
 
 
